//+------------------------------------------------------------------+
//|                                                         3ema.mq4 |
//|                                                kniterr@gmail.com |
//+------------------------------------------------------------------+

extern double Lots         = 1;
extern bool   MM           = true;
extern double RiskPerTrade = 10;
extern double Ma1          = 8;
extern double Ma2          = 8;
extern double Ma3          = 20;
extern int    start        = 8;
extern int    end          = 16;
extern double TakeProfit   = 0;
extern double StopLoss     = 0;
extern double TrailingStop = 300;
extern double Ma1_type     = 1;
extern double Ma2_type     = 1;
extern double Ma3_type     = 0;
extern int    Magic        = 250879;
extern int    Slippage     = 30;
double Ma1p, Ma1c, Ma2c, Ma2p, Ma3c, Ma3p;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int start()
  {
   
   int cnt, ticket, total;
   if(Bars<100)
     {
      Print("bars less than 100");
      return(0);  
     }
 
// variables
   Ma1p  = iMA(NULL,0,Ma1,0,Ma1_type,PRICE_LOW,1); 
   Ma1c  = iMA(NULL,0,Ma1,0,Ma1_type,PRICE_LOW,0); 
   Ma2c  = iMA(NULL,0,Ma2,0,Ma2_type,PRICE_HIGH,0); 
   Ma2p  = iMA(NULL,0,Ma2,0,Ma2_type,PRICE_HIGH,1); 
   Ma3c  = iMA(NULL,0,Ma3,0,Ma3_type,PRICE_CLOSE,0);
   Ma3p  = iMA(NULL,0,Ma3,0,Ma3_type,PRICE_CLOSE,1);
   
   
   double SL, TP;

//   GetEven();
   SL = 0;
   TP = 0;
   total=OrdersTotal();
   if(total<1) 
     {
      // tylko jedno zlecenie na raz
      Lots = GetLots();
      if(AccountFreeMargin()<(1000*Lots))
        {
         Print("We have no money. Free Margin = ", AccountFreeMargin());
         return(0);  // sprawdzenie zabezpieczenia
        }
      // wyszukanie sygnalu
      GetSignal();
      // BUY
      if(GetSignal() == 1)
        {if (StopLoss >0) SL=Ask-StopLoss*Point; else SL=0;
         if (TakeProfit >0) TP = Ask+TakeProfit*Point; else TP=0;
         ticket=OrderSend(Symbol(),OP_BUY,Lots,Ask,Slippage,SL,TP,"3ema",Magic,0,Green);
         if(ticket>0)
           { 
            if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES)) Print("BUY order opened : ",OrderOpenPrice());
           }
         else Print("Error opening BUY order : ",GetLastError()); 
         return(0); 
        }
      // SELL
      if(GetSignal() == -1)
        {if (StopLoss >0) SL = Bid+StopLoss*Point; else SL=0;
         if (TakeProfit >0) TP = Bid-TakeProfit*Point; else TP=0;
         ticket=OrderSend(Symbol(),OP_SELL,Lots,Bid,Slippage,SL,TP,"3ema",Magic,0,Red);
         if(ticket>0)
           {
            if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES)) Print("SELL order opened : ",OrderOpenPrice());
           }
         else Print("Error opening SELL order : ",GetLastError()); 
         return(0); 
        }
      return(0);
     }
   // it is important to enter the market correctly, 
   // but it is more important to exit it correctly...   
   for(cnt=0;cnt<total;cnt++)
     {
      OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
      if(OrderType()<=OP_SELL &&   // check for opened position 
         OrderSymbol()==Symbol())  // check for symbol
        {
         if(OrderType()==OP_BUY)   // long position is opened
           {
            // warunek zamkniecia poza SL/TP
           if(Ma2c < Ma3c && Ma2p > Ma3p)
                  {
                 OrderClose(OrderTicket(),OrderLots(),Bid,Slippage,Violet); // close position
                 return(0); // exit
                }
            // check for trailing stop
            if(TrailingStop>0)  
              {                 
               if(Bid-OrderOpenPrice()>Point*TrailingStop)
                 {
                  if(OrderStopLoss()<Bid-Point*TrailingStop)
                    {
                     OrderModify(OrderTicket(),OrderOpenPrice(),Bid-Point*TrailingStop,OrderTakeProfit(),0,Green);
                     return(0);
                    }
                 }
              }
           }
         else // go to short position
           {
            // warunek zamkniecia poza SL/TP
            if(Ma1c > Ma3c && Ma1p < Ma3p)
  
              {
               OrderClose(OrderTicket(),OrderLots(),Ask,Slippage,Violet); // close position
               return(0); // exit
              }
            // check for trailing stop
            if(TrailingStop>0)  
              {                 
               if((OrderOpenPrice()-Ask)>(Point*TrailingStop))
                 {
                  if((OrderStopLoss()>(Ask+Point*TrailingStop)) || (OrderStopLoss()==0))
                    {
                     OrderModify(OrderTicket(),OrderOpenPrice(),Ask+Point*TrailingStop,OrderTakeProfit(),0,Red);
                     return(0);
                    }
                 }
              }
           }
        }
     }
   return(0);
  }
double GetSignal()
   {
     if (Hour()>start && Hour()<end) 
     {
      double signal = 0;
      if (Ma1p<=Ma3p && Ma1c>Ma3c && signal != 1) signal = 1; //long
      if (Ma2p>=Ma3p && Ma2c<Ma3c && signal !=-1) signal = -1; //short
      return(signal);
     } else return(0);     
   }  
  
double GetLots()
   {
   double Lot;
   Lot=NormalizeDouble(AccountEquity()*RiskPerTrade/100/1000,1);// Calculate the amount of lots  
      double Min_Lot = MarketInfo(Symbol(), MODE_MINLOT);   // Minimum allowed lot value
   if (MM == false) Lot=Lots;
      if (Lot == 0 ) Lot = Min_Lot;
   return(Lot);
   }
   

int deinit()
  {
//   ObjectsDeleteAll();
   return(0);
  }
// the end.